scala.reflect.generic.Symbols

# AbsSymbol

#### abstract class AbsSymbol extends HasFlags

Self Type
  Symbol
Source
  Symbols.scala

Linear Supertypes
HasFlags, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. AbsSymbol
2. HasFlags
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new AbsSymbol()

### Type Members

1. #### type AccessBoundaryType = Symbol

   Definition Classes
     AbsSymbol → HasFlags

2. #### type AnnotationType = AnnotationInfo

   Definition Classes
     AbsSymbol → HasFlags

3. #### type FlagsType = Long

   Definition Classes
     AbsSymbol → HasFlags

### Abstract Value Members

1. #### abstract def annotations: List[AnnotationType]

   A list of annotations attached to this entity.

   A list of annotations attached to this entity.

   Definition Classes
     HasFlags

2. #### abstract def flags: Long

   The flags of this symbol

   The flags of this symbol

   Definition Classes
     AbsSymbol → HasFlags

3. #### abstract def hasFlagsToString(mask: FlagsType): String

   The printable representation of this entity's flags and access boundary, restricted to flags in the given mask.

   The printable representation of this entity's flags and access boundary, restricted to flags in the given mask.

   Definition Classes
     HasFlags

4. #### abstract def lazyAccessor: Symbol

   If symbol is a lazy val, it's lazy accessor

5. #### abstract def linkedClassOfClass: Symbol

   For a module class its linked class, for a plain class the module class of its linked module.

   For a module class its linked class, for a plain class the module class of its linked module. For instance object Foo class Foo

   Then object Foo has a `moduleClass' (invisible to the user, the backend calls it Foo$ linkedClassOfClass goes from class Foo$ to class Foo, and back.`

6. #### abstract def moduleClass: Symbol

   If symbol is an object definition, it's implied associated class, otherwise NoSymbol

7. #### abstract def name: Name

   The name of the symbol as a member of the `Name` type.

8. #### abstract def newAbstractType(name: TypeName, pos: Position = NoPosition): Symbol

9. #### abstract def newAliasType(name: TypeName, pos: Position = NoPosition): Symbol

10. #### abstract def newClass(name: TypeName, pos: Position = NoPosition): Symbol

11. #### abstract def newMethod(name: TermName, pos: Position = NoPosition): Symbol

12. #### abstract def newModule(name: TermName, clazz: Symbol, pos: Position = NoPosition): Symbol

13. #### abstract def newModuleClass(name: TypeName, pos: Position = NoPosition): Symbol

14. #### abstract def newValue(name: TermName, pos: Position = NoPosition): Symbol

15. #### abstract def owner: Symbol

    The owner of this symbol.

16. #### abstract def privateWithin: Symbol

    Set when symbol has a modifier of the form private[X], NoSymbol otherwise.

    Set when symbol has a modifier of the form private[X], NoSymbol otherwise.

    Definition Classes
      AbsSymbol → HasFlags

17. #### abstract def rawInfo: Type

    The raw info of the type

18. #### abstract def typeOfThis: Type

    If this symbol is a class or trait, its self type, otherwise the type of the symbol itse;lf

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### def addAnnotation(annot: AnnotationInfo): Unit

7. #### def addChild(sym: Symbol): Unit

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

10. #### def decodedName: String

    The decoded name of the symbol, e.

    The decoded name of the symbol, e.g. `==` instead of `$eq$eq`.

11. #### def enclClass: Symbol

    The next enclosing class

12. #### def enclMethod: Symbol

    The next enclosing method

13. #### def encodedName: String

    The name of the symbol before decoding, e.

    The name of the symbol before decoding, e.g. `$eq$eq` instead of `==`.

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

17. #### def flags_=(flags: Long): Unit

18. #### final def fullName: String

    The encoded full path name of this symbol, where outer names and inner names are separated by periods.

19. #### final def fullName(separator: Char): String

    The encoded full path name of this symbol, where outer names and inner names are separated by `separator` characters.

    The encoded full path name of this symbol, where outer names and inner names are separated by `separator` characters. Never translates expansions of operators back to operator symbol. Never adds id.

20. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def hasAbstractFlag: Boolean

    Definition Classes
      HasFlags

22. #### final def hasAccessBoundary: Boolean

    Whether this entity has a "privateWithin" visibility barrier attached.

    Whether this entity has a "privateWithin" visibility barrier attached.

    Definition Classes
      AbsSymbol → HasFlags

23. #### def hasAccessorFlag: Boolean

    Definition Classes
      HasFlags

24. #### final def hasAllFlags(mask: Long): Boolean

    Does symbol have ALL the flags in `mask` set?

    Does symbol have ALL the flags in `mask` set?

    Definition Classes
      AbsSymbol → HasFlags

25. #### def hasContravariantFlag: Boolean

    Definition Classes
      HasFlags

26. #### def hasDefault: Boolean

    Definition Classes
      HasFlags

27. #### def hasDefaultFlag: Boolean

    Definition Classes
      HasFlags

28. #### final def hasFlag(mask: Long): Boolean

    Does symbol have ANY flag in `mask` set?

    Does symbol have ANY flag in `mask` set?

    Definition Classes
      AbsSymbol → HasFlags

29. #### def hasInConstructorFlag: Boolean

    Definition Classes
      HasFlags

30. #### def hasLocalFlag: Boolean

    Definition Classes
      HasFlags

31. #### def hasModuleFlag: Boolean

    Definition Classes
      HasFlags

32. #### def hasNoFlags(mask: Long): Boolean

    Whether this entity has NONE of the flags in the given mask.

    Whether this entity has NONE of the flags in the given mask.

    Definition Classes
      HasFlags

33. #### def hasPackageFlag: Boolean

    Definition Classes
      HasFlags

34. #### def hasPreSuperFlag: Boolean

    Definition Classes
      HasFlags

35. #### def hasStableFlag: Boolean

    Definition Classes
      HasFlags

36. #### def hasStaticFlag: Boolean

    Definition Classes
      HasFlags

37. #### def hasTraitFlag: Boolean

    Definition Classes
      HasFlags

38. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

39. #### def info: Type

    The info of the symbol.

    The info of the symbol. This is like tpe, except for class symbols where the `info` describes the contents of the class whereas the `tpe` is a reference to the class.

40. #### def info_=(tp: Type): Unit

41. #### final def isAbstractClass: Boolean

42. #### def isAbstractOverride: Boolean

    Definition Classes
      HasFlags

43. #### def isAbstractType: Boolean

44. #### def isAliasType: Boolean

45. #### final def isBridge: Boolean

46. #### def isByNameParam: Boolean

    Definition Classes
      HasFlags

47. #### def isCase: Boolean

    Definition Classes
      HasFlags

48. #### def isCaseAccessor: Boolean

    Definition Classes
      HasFlags

49. #### def isClass: Boolean

50. #### final def isContravariant: Boolean

51. #### final def isCovariant: Boolean

52. #### def isDefaultInit: Boolean

    Definition Classes
      HasFlags

53. #### def isDeferred: Boolean

    Definition Classes
      HasFlags

54. #### final def isEarlyInitialized: Boolean

55. #### def isEffectiveRoot: Boolean

    Is this symbol an effective root for fullname string?

56. #### final def isEmptyPackage: Boolean

    Package tests

57. #### final def isEmptyPackageClass: Boolean

58. #### final def isExistentiallyBound: Boolean

59. #### def isFinal: Boolean

    Definition Classes
      HasFlags

60. #### final def isImplClass: Boolean

61. #### def isImplicit: Boolean

    Definition Classes
      HasFlags

62. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

63. #### def isInterface: Boolean

    Definition Classes
      HasFlags

64. #### def isJavaDefined: Boolean

    Definition Classes
      HasFlags

65. #### def isLabel: Boolean

    Definition Classes
      HasFlags

66. #### def isLazy: Boolean

    Definition Classes
      HasFlags

67. #### final def isLazyAccessor: Boolean

68. #### def isLifted: Boolean

    Definition Classes
      HasFlags

69. #### final def isMethod: Boolean

70. #### final def isModule: Boolean

71. #### final def isModuleClass: Boolean

72. #### def isMutable: Boolean

    Definition Classes
      HasFlags

73. #### final def isOverloaded: Boolean

74. #### def isOverride: Boolean

    Definition Classes
      HasFlags

75. #### final def isPackage: Boolean

76. #### final def isPackageClass: Boolean

77. #### def isParamAccessor: Boolean

    Definition Classes
      HasFlags

78. #### def isParameter: Boolean

    Definition Classes
      HasFlags

79. #### def isPrivate: Boolean

    Definition Classes
      HasFlags

80. #### def isPrivateLocal: Boolean

    Definition Classes
      HasFlags

81. #### def isProtected: Boolean

    Definition Classes
      HasFlags

82. #### def isProtectedLocal: Boolean

    Definition Classes
      HasFlags

83. #### def isPublic: Boolean

    Definition Classes
      HasFlags

84. #### final def isRefinementClass: Boolean

85. #### final def isRoot: Boolean

86. #### final def isRootPackage: Boolean

87. #### def isSealed: Boolean

    Definition Classes
      HasFlags

88. #### final def isSourceMethod: Boolean

89. #### def isSuperAccessor: Boolean

    Definition Classes
      HasFlags

90. #### def isSynthetic: Boolean

    Definition Classes
      HasFlags

91. #### def isTerm: Boolean

92. #### def isTrait: Boolean

    Definition Classes
      AbsSymbol → HasFlags

93. #### def isType: Boolean

94. #### final def isTypeParameter: Boolean

95. #### final def isVarargsMethod: Boolean

96. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

97. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

98. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

99. #### def orElse[T](alt: ⇒ Symbol): Symbol

    If this is NoSymbol, evaluate the argument: otherwise, this.

100. #### def owner_=(sym: Symbol): Unit

101. #### def privateWithin_=(sym: Symbol): Unit

102. #### def sourceModule: Symbol

     The module corresponding to this module class (note that this is not updated when a module is cloned), or NoSymbol if this is not a ModuleClass

103. #### def sourceModule_=(sym: Symbol): Unit

104. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

105. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       AnyRef → Any

106. #### def tpe: Type

     The type of the symbol

107. #### def typeOfThis_=(tp: Type): Unit

108. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

109. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

110. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

### Deprecated Value Members

1. #### def isAbstract: Boolean

   Definition Classes
     HasFlags
   Annotations
     @deprecated
   Deprecated

     (Since version 2.9.0)

### Inherited from HasFlags

### Inherited from AnyRef

### Inherited from Any